
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Learning_articlesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const learning_articles = await db.learning_articles.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        topic: data.topic
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        level: data.level
        ||
        null
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        
        await learning_articles.setTags(data.tags || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.learning_articles.getTableName(),
                belongsToColumn: 'cover_images',
                belongsToId: learning_articles.id,
            },
            data.cover_images,
            options,
        );
        

        return learning_articles;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const learning_articlesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                topic: item.topic
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                level: item.level
            ||
            null
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const learning_articles = await db.learning_articles.bulkCreate(learning_articlesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < learning_articles.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.learning_articles.getTableName(),
                    belongsToColumn: 'cover_images',
                    belongsToId: learning_articles[i].id,
                },
                data[i].cover_images,
                options,
            );
        }
        

        return learning_articles;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const learning_articles = await db.learning_articles.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.topic !== undefined) updatePayload.topic = data.topic;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.level !== undefined) updatePayload.level = data.level;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await learning_articles.update(updatePayload, {transaction});

        
        

        
        
        if (data.tags !== undefined) {
            await learning_articles.setTags(data.tags, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.learning_articles.getTableName(),
                belongsToColumn: 'cover_images',
                belongsToId: learning_articles.id,
            },
            data.cover_images,
            options,
        );
        

        return learning_articles;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const learning_articles = await db.learning_articles.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of learning_articles) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of learning_articles) {
                await record.destroy({transaction});
            }
        });


        return learning_articles;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const learning_articles = await db.learning_articles.findByPk(id, options);

        await learning_articles.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await learning_articles.destroy({
            transaction
        });

        return learning_articles;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const learning_articles = await db.learning_articles.findOne(
            { where },
            { transaction },
        );

        if (!learning_articles) {
            return learning_articles;
        }

        const output = learning_articles.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.cover_images = await learning_articles.getCover_images({
            transaction
        });
        
        
        output.tags = await learning_articles.getTags({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [


      {
        model: db.tags,
        as: 'tags',
        required: false,
      },


      {
        model: db.file,
        as: 'cover_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_articles',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_articles',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'learning_articles',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            

            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.topic) {
                where = {
                    ...where,
                topic: filter.topic,
            };
            }
            
            if (filter.level) {
                where = {
                    ...where,
                level: filter.level,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            



      if (filter.tags) {
        const searchTerms = filter.tags.split('|');

        include = [
          {
            model: db.tags,
            as: 'tags_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.learning_articles.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'learning_articles',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.learning_articles.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

